/*
 *      Program do przegladania logow z ekg.
 *      Klasa bazowa dla obiektu komendy.
 *
 *
 *      copyright (c) 2003 by Lukasz Bartnik
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License Version 2 as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "command.hh"

command_base::command_base(const std::string &str, std::vector<std::string> &events)
    :_id(str),_events(events) {}


command_base::~command_base() {}


/*
 * command::is_equal()
 * operator==()
 *
 * czy identyfikator komendy odpowiada podanemu stringowi
 *
 *  - str - string do sprawdzenia
 */
bool command_base::is_equal(const std::string &str) const {
    return _id == str;
}


bool operator==(const command_base &c, const std::string &str) {
    return c.is_equal(str);
}

