/*
 *      Program do przegladania logow z ekg.
 *      Pomoc w programie.
 *
 *
 *      copyright (c) 2003 by Lukasz Bartnik
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License Version 2 as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "help.hh"


/*
 * command_help::run()
 *
 * wywoluje dzialanie dla komendy quit - argumenty nie sa sprawdzane
 */
void command_help::run(const std::vector<std::string> &argv) {
    if(!argv.size()) {
	std::string help = "\n   Dostpne komendy:\n\n";

	for(std::vector<command_base*>::iterator i=_commands->begin();
		i!=_commands->end(); ++i)
	{
	    help += (*i)->help_short()+"\n";
	}

	help += "\nWpisz help help, aby otrzyma wicej pomocy.";

	_mw->print(help.c_str(), "\\c010:\\c600:\\c610:\\d ");
    }
    else if(argv.size() == 1) {
	for(std::vector<command_base*>::iterator i=_commands->begin();
		i!=_commands->end(); ++i)
	{
	    if((*i)->is_equal(argv[0])) {
		_mw->print((*i)->help_long().c_str(), "\\c010:\\c600:\\c610:\\d ");
		return;
	    }
	}

	std::string tmp = "Nie ma dostpnej pomocy dla polecenia: " + argv[0];
	_mw->print(tmp.c_str(), "\\c010:\\c100:\\c110:\\d ");
    }
    else {
	_mw->print("Zbyt duo argumentw dla komendy help.", "\\c010:\\c100:\\c110:\\d ");
    }

    _mw->show_last();
}


const std::vector<std::string>& 
command_help::completition(void) {
    return _completition;
}

const std::vector<std::string>& 
command_help::complete(const std::string &arg) {
    _completition.clear();

    for(std::vector<command_base*>::iterator i=_commands->begin();
	    i!=_commands->end(); ++i)
	if((*i)->name().find(arg) == 0)
	    _completition.push_back((*i)->name());

    return _completition;
}



/*
 * pomoc
 */
std::string command_help::help_short(void) {
    return " \\c710help\\d    - ekran pomocy";
}

std::string command_help::help_long(void) {
    return "\\c710help\\d <komenda> - wywietla pomoc dla danej komendy";
}
