/*
 *      Program do przegladania logow z ekg.
 *      Rozne komendy.
 *
 *
 *      copyright (c) 2003 by Lukasz Bartnik
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License Version 2 as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "list.hh"


/*
 * command_help::run()
 *
 * wywoluje dzialanie dla komendy quit - argumenty nie sa sprawdzane
 */

#define __prepare_tmp_string tmp = i->nick;\
	    tmp += "\\c610/\\d";\
	    tmp += string_cast(i->uin);\
	    unsigned int size = ((38-(int)tmp.size())<0)?0:(38-tmp.size());\
	    for(unsigned int j=0; j<size; ++j) tmp+=' ';\
	    tmp += "chatw: " + string_cast(i->chats);\
	    tmp += ", wiadomoci: " + string_cast(i->msgs);
/* koniec definicji */ 
 
void command_list::run(const std::vector<std::string> &argv) {
    bool write_one_entry = false;

    build_list();

    if(argv.size() == 0) {
	_mw->print("Lista posortowana wg. nickw.", "\\c010:\\c200:\\c210:\\d ");
    }
    else if(argv.size() == 1) {
	if(argv[0] == "-n") {
	    _mw->print("Lista posortowana wg. nickw.", "\\c010:\\c200:\\c210:\\d ");
	}
	else if(argv[0] == "-u") {
	    _mw->print("Lista posortowana wg. uinw.", "\\c010:\\c200:\\c210:\\d ");
	    std::sort(_list.begin(),_list.end(),sort_uin());
	}
	else if(argv[0] == "-c") {
	    _mw->print("Lista posortowana wg. iloci chatw.", "\\c010:\\c200:\\c210:\\d ");
	    std::sort(_list.begin(),_list.end(),sort_chat());
	}
	else if(argv[0] == "-m") {
	    _mw->print("Lista posortowana wg. iloci wiadomoci.", "\\c010:\\c200:\\c210:\\d ");
	    std::sort(_list.begin(),_list.end(),sort_msg());
	}
	else if(argv[0] == "-a") {
	    std::string tmp = "Razem chatw: ";
	    tmp += string_cast(_all_chats);
	    tmp += ", wiadomoci: " + string_cast(_all_msgs) + ".";
	    _mw->print(tmp.c_str(), "\\c010:\\c200:\\c210:\\d ");
	    _mw->show_last();
	    return;
	}
	else {
	    /* zrobimy wyswietlanie statystyk dla jednej osoby */
	    write_one_entry = true;


	/*  std::string tmp = "Nieprawidowy argument dla komendy list: " + argv[0];
	    _mw->print(tmp.c_str(), "\\c010:\\c100:\\c110:\\d ");
	    _mw->show_last();
	    return;
	*/
	}
    }
    else {
	_mw->print("Zbyt duo argumentw dla komendy list.", "\\c010:\\c100:\\c110:\\d ");
	_mw->show_last();
	return;
    }

    /* ### wypisanie na ekran ### */
    if(!write_one_entry) {
	for(std::vector<l_ent>::iterator i=_list.begin();
	    i!=_list.end(); ++i)
	{
	    std::string tmp;
	    __prepare_tmp_string
	    _mw->print(tmp.c_str(), "\\c010:\\c200:\\c210:\\d ");
	}
	if(argv.size() && argv[0] != "-n")
	    std::sort(_list.begin(),_list.end(),sort_nick());
    } else {
	std::vector<l_ent>::iterator i;

	for(i=_list.begin(); i!=_list.end(); ++i)
	{
	    if(i->nick == argv[0])
		break;
	}
	if(i != _list.end()) {
	    std::string tmp;
	    __prepare_tmp_string
	    _mw->print(tmp.c_str(), "\\c010:\\c200:\\c210:\\d ");
	} else {
	    _mw->print("Nie ma nicka: " + argv[0], "\\c010:\\c100:\\c110:\\d ");
	    
	}
    }

    _mw->show_last();
}


const std::vector<std::string>& 
command_list::completition(void) {
    return _completition;
}

const std::vector<std::string> &
command_list::complete(const std::string &arg) {
    build_list();

    if(arg == "-") {
	_completition.clear();
	_completition.push_back("a");
	_completition.push_back("c");
	_completition.push_back("m");
	_completition.push_back("n");
	_completition.push_back("u");
	return _completition;
    } else if(arg[0] == '-') {
	_completition.clear();
	return _completition;
    } else {
	_completition.clear();
	for(std::vector<l_ent>::iterator i=_list.begin();
	    i!=_list.end(); ++i)
	    if(i->nick.find(arg) == 0) {
		_completition.push_back(i->nick);
	    }

	return _completition;
    }
}


/*
 * command_list::build_list()
 *
 * przygotowuje dane dla komendy
 */
void command_list::build_list(void) {
    if(_list.size() == 0)
	for(int i=0; i<_db->size(); ++i) {
	    l_ent t(_db->get_uinlog(i)->nick(),_db->get_uinlog(i)->uin(),
		    _db->get_uinlog(i)->size(),_db->get_uinlog(i)->_msg_no);
	    _list.push_back(t);
	    _all_chats += _db->get_uinlog(i)->size();
	    _all_msgs += _db->get_uinlog(i)->_msg_no;
	}
}


/*
 * pomoc
 */
std::string command_list::help_short(void) {
    return " \\c710list\\d    - lista kontaktw";
}

std::string command_list::help_long(void) {
    return "\\c710list\\d [\\c710cig\\d] - wywietla list kontaktw\n\n"
	     "   Parametry:\n"
	     " -n - posortuj wg. nickw\n"
	     " -u - posortuj wg. uinw\n"
	     " -c - posortuj wg. iloci chatw\n"
	     " -m - posortuj wg. iloci wiadomoci\n"
	     " -a - podsumowanie listy kontaktw\n\n"
	     "Dla samego list domylnie przyjmowane jest -n.\n"
	     "Jeli poda si cig, wypisane bd dane dla nicka mu odpowiadajcego.";
}
